import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import { AppComponent } from './app.component';
import { ProjectsComponent } from './components/projects/projects.component';
import { NotfoundComponent } from './components/notfound/notfound.component';
import { ProjectComponent } from './components/project/project.component';
import { FlowComponent } from './components/flow/flow.component';
import { NewProjectComponent } from './components/new-project/new-project.component';
import { ImprintComponent } from './components/imprint/imprint.component';
import { TestComponent } from './components/test/test.component';
import { MocksComponent } from './components/mocks/mocks.component';
import { NewExternalMockComponent } from './components/new-external-mock/new-external-mock.component';
import { NewManualMockComponent } from './components/new-manual-mock/new-manual-mock.component';
import { FlowsComponent } from './components/flows/flows.component';
import { DeleteProjectComponent } from './components/delete-project/delete-project.component';
import { LoopsComponent } from './components/loops/loops.component';
import { LoopComponent } from './components/loop/loop.component';


const routes: Routes = [
      { path: '', component: ProjectsComponent },
      { path: 'project/new', component: NewProjectComponent },
      { path: 'project/:projectId', component: ProjectComponent },
      { path: 'project/:projectId/loops/:loopId', component: LoopComponent },
      { path: 'project/:projectId/loops', component: LoopsComponent },
      { path: 'project/:projectId/settings', component: DeleteProjectComponent },
      { path: 'project/:projectId/flow', component: FlowsComponent },
      { path: 'project/:projectId/flow/:flowId', component: FlowComponent },
      { path: 'project/:projectId/flow/:flowId/test', component: TestComponent },
      { path: 'project/:projectId/flow/:flowId/test/:testId', component: TestComponent },
      { path: 'project/:projectId/mocks', component: MocksComponent },
      { path: 'project/:projectId/mocks/external', component: NewExternalMockComponent },
      { path: 'project/:projectId/mocks/external/:mockId', component: NewExternalMockComponent },
      { path: 'project/:projectId/mocks/manual', component: NewManualMockComponent },
      { path: 'project/:projectId/mocks/manual/:mockId', component: NewManualMockComponent },
      { path: 'impressum', component: ImprintComponent },
      { path: 'notfound', component: NotfoundComponent },
      { path: '**', redirectTo: 'notfound'} //has to be the last entry
];

@NgModule({
  imports: [RouterModule.forRoot(routes)],
  exports: [RouterModule]
})
export class AppRoutingModule { }
