import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';

import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';
import { InputsModule, ButtonsModule, CarouselModule, IconsModule, NavbarModule, WavesModule, TableModule } from 'angular-bootstrap-md';
import { ProjectsComponent } from './components/projects/projects.component';
import { NotfoundComponent } from './components/notfound/notfound.component';
import { HttpClientModule, HTTP_INTERCEPTORS } from '@angular/common/http';
import { TokenInterceptor } from './interceptors/token.interceptors';
import { ProjectComponent } from './components/project/project.component';
import { FlowPipe } from './pipes/flow.pipe';
import { BpmnDiagramComponent } from './components/bpmn-diagram/bpmn-diagram.component';
import { FlowComponent } from './components/flow/flow.component';
import { NewProjectComponent } from './components/new-project/new-project.component';
import { ImprintComponent } from './components/imprint/imprint.component';
import { TaskVariablePipe } from './pipes/task-variable.pipe';
import { TestComponent } from './components/test/test.component';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { DataTypePipe } from './pipes/data-type.pipe';
import { VariableProposalsPipe } from './pipes/variable-proposals.pipe';
import { LoadingComponent } from './components/loading/loading.component';
import { EndCheckPipe } from './pipes/endchecks.pipe';
import { MocksComponent } from './components/mocks/mocks.component';
import { NewManualMockComponent } from './components/new-manual-mock/new-manual-mock.component';
import { NewExternalMockComponent } from './components/new-external-mock/new-external-mock.component';
import { MockRulesPipe } from './pipes/mock-rules.pipe';
import { FlowsComponent } from './components/flows/flows.component';
import { DeleteProjectComponent } from './components/delete-project/delete-project.component';
import { LoopsComponent } from './components/loops/loops.component';
import { LoopComponent } from './components/loop/loop.component';

@NgModule({
  declarations: [
    AppComponent,
    ProjectsComponent,
    NotfoundComponent,
    ProjectComponent,
    FlowPipe,
    BpmnDiagramComponent,
    FlowComponent,
    NewProjectComponent,
    ImprintComponent,
    TaskVariablePipe,
    TestComponent,
    DataTypePipe,
    VariableProposalsPipe,
    LoadingComponent,
    EndCheckPipe,
    MocksComponent,
    NewManualMockComponent,
    NewExternalMockComponent,
    MockRulesPipe,
    FlowsComponent,
    DeleteProjectComponent,
    LoopsComponent,
    LoopComponent
  ],
  imports: [
    BrowserModule,
    AppRoutingModule,
    HttpClientModule,

    FormsModule,
    ReactiveFormsModule,

    ButtonsModule,
    CarouselModule,
    IconsModule,
    InputsModule,
    NavbarModule,
    TableModule
  ],
  providers: [
    {
      provide: HTTP_INTERCEPTORS,
      useClass: TokenInterceptor,
      multi: true
    }
  ],
  bootstrap: [AppComponent]
})
export class AppModule { }
