import { Pipe, PipeTransform } from '@angular/core';
import { BPMNMockRule } from '../models/bpmn-mock-rule';
import { VariableValue } from '../models/variable-value';
import { BPMNComparison } from '../models/comparison';

@Pipe({
  name: 'mockRules'
})
export class MockRulesPipe implements PipeTransform {

  transform(value: BPMNMockRule, ...args: unknown[]): unknown {
    let conditions = this.getComparisons(value.comparisons).join(", ");"";
    let s2 = this.getValueDeclarations(value.variables).join(", ");;
    return "if [ " + conditions + " ] set [ " + s2 + " ]"; 
  }

  private getComparisons(comparisons: Array<BPMNComparison>): Array<String> {
    var valueComparisons = new Array<String>();
    for(let variableComparison of comparisons) {
      let comparison = variableComparison.variable + variableComparison.compareOperator + variableComparison.value;
      valueComparisons.push(comparison);
    }
    return valueComparisons;
  }

  private getValueDeclarations(variableValues: Array<VariableValue>): Array<String> {
    var valueDeclarations = Array<String>();
    for(let variableValue of variableValues) {
      var declaration = variableValue.variable + "=" + variableValue.value;
      valueDeclarations.push(declaration);
    }

    return valueDeclarations;
  }
}
