import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { environment } from 'src/environments/environment';
import { BPMNFlowSet } from '../models/bpmn-flow-set';

@Injectable({
  providedIn: 'root'
})
export class FileService {

  constructor(public http: HttpClient) { }

  public async getBPMNDiagram(projectId: number): Promise<string> {
    //const url = 'https://cdn.staticaly.com/gh/bpmn-io/bpmn-js-examples/dfceecba/url-viewer/resources/pizza-collaboration.bpmn';
    const url = `${environment.apiBaseUrl}project/${projectId}/bpmn/x`;
    return <string>await this.http.get(url, {responseType: 'text'}).toPromise();
  }
}
